﻿using System.Collections.Generic;

namespace Parade.Metadata.Asf
{
	/// <summary>
	/// 定義済みのタグに関する情報を提供します。
	/// </summary>
	public static class AsfDefinedTags
	{
		/// <summary>
		/// クラスを初期化します。
		/// </summary>
		static AsfDefinedTags()
		{
			AsfDefinedTags.AsfLeakyBucketPairs                 = new AsfTagInfo( "ASFLeakyBucketPairs",                 AsfTagDataType.Binary );
			AsfDefinedTags.AspectRatioX                        = new AsfTagInfo( "AspectRatioX",                        AsfTagDataType.UInt32 );
			AsfDefinedTags.AspectRatioY                        = new AsfTagInfo( "AspectRatioY",                        AsfTagDataType.UInt32 );
			AsfDefinedTags.Author                              = new AsfTagInfo( "Author",                              AsfTagDataType.String, true );
			AsfDefinedTags.AverageLevel                        = new AsfTagInfo( "AverageLevel",                        AsfTagDataType.UInt32, true );
			AsfDefinedTags.BannerImageData                     = new AsfTagInfo( "BannerImageData",                     AsfTagDataType.Binary );
			AsfDefinedTags.BannerImageType                     = new AsfTagInfo( "BannerImageType",                     AsfTagDataType.UInt32 );
			AsfDefinedTags.BannerImageUrl                      = new AsfTagInfo( "BannerImageURL",                      AsfTagDataType.String );
			AsfDefinedTags.Bitrate                             = new AsfTagInfo( "Bitrate",                             AsfTagDataType.UInt32 );
			AsfDefinedTags.Broadcast                           = new AsfTagInfo( "Broadcast",                           AsfTagDataType.Bool   );
			AsfDefinedTags.BufferAverage                       = new AsfTagInfo( "BufferAverage",                       AsfTagDataType.UInt32 );
			AsfDefinedTags.CanSkipBackward                     = new AsfTagInfo( "Can_Skip_Backward",                   AsfTagDataType.Bool   );
			AsfDefinedTags.CanSkipForward                      = new AsfTagInfo( "Can_Skip_Forward",                    AsfTagDataType.Bool   );
			AsfDefinedTags.Copyright                           = new AsfTagInfo( "Copyright",                           AsfTagDataType.String, true );
			AsfDefinedTags.CopyrightUrl                        = new AsfTagInfo( "CopyrightURL",                        AsfTagDataType.String );
			AsfDefinedTags.CurrentBitrate                      = new AsfTagInfo( "CurrentBitrate",                      AsfTagDataType.UInt32 );
			AsfDefinedTags.Description                         = new AsfTagInfo( "Description",                         AsfTagDataType.String, true );
			AsfDefinedTags.DrmContentId                        = new AsfTagInfo( "DRM_ContentID",                       AsfTagDataType.String );
			AsfDefinedTags.DrmDrmHeaderContentDistributor      = new AsfTagInfo( "DRM_DRMHeader_ContentDistributor",    AsfTagDataType.String );
			AsfDefinedTags.DrmDrmHeaderContentId               = new AsfTagInfo( "DRM_DRMHeader_ContentID",             AsfTagDataType.String );
			AsfDefinedTags.DrmDrmHeaderIndividualizedVersion   = new AsfTagInfo( "DRM_DRMHeader_IndividualizedVersion", AsfTagDataType.String );
			AsfDefinedTags.DrmDrmHeaderKeyId                   = new AsfTagInfo( "DRM_DRMHeader_KeyID",                 AsfTagDataType.String );
			AsfDefinedTags.DrmDrmHeaderLicenseAcqUrl           = new AsfTagInfo( "DRM_DRMHeader_LicenseAcqURL",         AsfTagDataType.String );
			AsfDefinedTags.DrmDrmHeaderSubscriptionContentId   = new AsfTagInfo( "DRM_DRMHeader_SubscriptionContentID", AsfTagDataType.String );
			AsfDefinedTags.DrmDrmHeader                        = new AsfTagInfo( "DRM_DRMHeader",                       AsfTagDataType.String );
			AsfDefinedTags.DrmIndividualizedVersion            = new AsfTagInfo( "DRM_IndividualizedVersion",           AsfTagDataType.String );
			AsfDefinedTags.DrmKeyId                            = new AsfTagInfo( "DRM_KeyID",                           AsfTagDataType.String );
			AsfDefinedTags.DrmLaSignatureCert                  = new AsfTagInfo( "DRM_LASignatureCert",                 AsfTagDataType.String );
			AsfDefinedTags.DrmLaSignatureLicSrvCert            = new AsfTagInfo( "DRM_LASignatureLicSrvCert",           AsfTagDataType.String );
			AsfDefinedTags.DrmLaSignaturePrivKey               = new AsfTagInfo( "DRM_LASignaturePrivKey",              AsfTagDataType.String );
			AsfDefinedTags.DrmLaSignatureRootCert              = new AsfTagInfo( "DRM_LASignatureRootCert",             AsfTagDataType.String );
			AsfDefinedTags.DrmLicenseAcqUrl                    = new AsfTagInfo( "DRM_LicenseAcqURL",                   AsfTagDataType.String );
			AsfDefinedTags.DrmLicenseId                        = new AsfTagInfo( "DRM_LicenseID",                       AsfTagDataType.String );
			AsfDefinedTags.DrmSourceId                         = new AsfTagInfo( "DRM_SourceID",                        AsfTagDataType.UInt32 );
			AsfDefinedTags.DrmV1LicenseAcqUrl                  = new AsfTagInfo( "DRM_V1LicenseAcqURL",                 AsfTagDataType.String );
			AsfDefinedTags.Duration                            = new AsfTagInfo( "Duration",                            AsfTagDataType.UInt64 );
			AsfDefinedTags.FileSize                            = new AsfTagInfo( "FileSize",                            AsfTagDataType.UInt64 );
			AsfDefinedTags.HasArbitraryDataStream              = new AsfTagInfo( "HasArbitraryDataStream",              AsfTagDataType.Bool   );
			AsfDefinedTags.HasAttachedImages                   = new AsfTagInfo( "HasAttachedImages",                   AsfTagDataType.Bool   );
			AsfDefinedTags.HasAudio                            = new AsfTagInfo( "HasAudio",                            AsfTagDataType.Bool   );
			AsfDefinedTags.HasFileTransferStream               = new AsfTagInfo( "HasFileTransferStream",               AsfTagDataType.Bool   );
			AsfDefinedTags.HasImage                            = new AsfTagInfo( "HasImage",                            AsfTagDataType.Bool   );
			AsfDefinedTags.HasScript                           = new AsfTagInfo( "HasScript",                           AsfTagDataType.Bool   );
			AsfDefinedTags.HasVideo                            = new AsfTagInfo( "HasVideo",                            AsfTagDataType.Bool   );
			AsfDefinedTags.IsProtected                         = new AsfTagInfo( "Is_Protected",                        AsfTagDataType.Bool   );
			AsfDefinedTags.IsTrusted                           = new AsfTagInfo( "Is_Trusted",                          AsfTagDataType.Bool   );
			AsfDefinedTags.Isan                                = new AsfTagInfo( "WM/ISAN",                             AsfTagDataType.String, true );
			AsfDefinedTags.IsVBR                               = new AsfTagInfo( "IsVBR",                               AsfTagDataType.Bool   );
			AsfDefinedTags.NscAddress                          = new AsfTagInfo( "NSC_Address",                         AsfTagDataType.String );
			AsfDefinedTags.NscDescription                      = new AsfTagInfo( "NSC_Description",                     AsfTagDataType.String );
			AsfDefinedTags.NscEmail                            = new AsfTagInfo( "NSC_Email",                           AsfTagDataType.String );
			AsfDefinedTags.NscName                             = new AsfTagInfo( "NSC_Name",                            AsfTagDataType.String );
			AsfDefinedTags.NscPhone                            = new AsfTagInfo( "NSC_Phone",                           AsfTagDataType.String );
			AsfDefinedTags.NumberOfFrames                      = new AsfTagInfo( "NumberOfFrames",                      AsfTagDataType.UInt64, true );
			AsfDefinedTags.OptimalBitrate                      = new AsfTagInfo( "OptimalBitrate",                      AsfTagDataType.UInt32 );
			AsfDefinedTags.PeakValue                           = new AsfTagInfo( "PeakValue",                           AsfTagDataType.UInt32, true );
			AsfDefinedTags.Rating                              = new AsfTagInfo( "Rating",                              AsfTagDataType.String, true );
			AsfDefinedTags.Seekable                            = new AsfTagInfo( "Seekable",                            AsfTagDataType.Bool   );
			AsfDefinedTags.Signature_Name                      = new AsfTagInfo( "Signature_Name",                      AsfTagDataType.String );
			AsfDefinedTags.Stridable                           = new AsfTagInfo( "Stridable",                           AsfTagDataType.Bool   );
			AsfDefinedTags.Title                               = new AsfTagInfo( "Title",                               AsfTagDataType.String, true );
			AsfDefinedTags.VbrPeak                             = new AsfTagInfo( "VBRPeak",                             AsfTagDataType.UInt32 );
			AsfDefinedTags.WmAlbumArtist                       = new AsfTagInfo( "WM/AlbumArtist",                      AsfTagDataType.String, true );
			AsfDefinedTags.WmAlbumCoverUrl                     = new AsfTagInfo( "WM/AlbumCoverURL",                    AsfTagDataType.String, true );
			AsfDefinedTags.WmAlbumTitle                        = new AsfTagInfo( "WM/AlbumTitle",                       AsfTagDataType.String, true );
			AsfDefinedTags.WmAsfPacketCount                    = new AsfTagInfo( "WM/ASFPacketCount",                   AsfTagDataType.UInt64 );
			AsfDefinedTags.WmAsfSecurityObjectsSize            = new AsfTagInfo( "WM/ASFSecurityObjectsSize",           AsfTagDataType.UInt64 );
			AsfDefinedTags.WmAudioFileUrl                      = new AsfTagInfo( "WM/AudioFileURL",                     AsfTagDataType.String, true );
			AsfDefinedTags.WmAudioSourceUrl                    = new AsfTagInfo( "WM/AudioSourceURL",                   AsfTagDataType.String, true );
			AsfDefinedTags.WmAuthorUrl                         = new AsfTagInfo( "WM/AuthorURL",                        AsfTagDataType.String, true );
			AsfDefinedTags.WmBeatsPerMinute                    = new AsfTagInfo( "WM/BeatsPerMinute",                   AsfTagDataType.String, true );
			AsfDefinedTags.WmCategory                          = new AsfTagInfo( "WM/Category",                         AsfTagDataType.String, true );
			AsfDefinedTags.WmCodec                             = new AsfTagInfo( "WM/Codec",                            AsfTagDataType.String );
			AsfDefinedTags.WmComposer                          = new AsfTagInfo( "WM/Composer",                         AsfTagDataType.String, true );
			AsfDefinedTags.WmConductor                         = new AsfTagInfo( "WM/Conductor",                        AsfTagDataType.String, true );
			AsfDefinedTags.WmContainerFormat                   = new AsfTagInfo( "WM/ContainerFormat",                  AsfTagDataType.Binary );
			AsfDefinedTags.WmContentDistributor                = new AsfTagInfo( "WM/ContentDistributor",               AsfTagDataType.String, true );
			AsfDefinedTags.WmContentGroupDescription           = new AsfTagInfo( "WM/ContentGroupDescription",          AsfTagDataType.String, true );
			AsfDefinedTags.WmDirector                          = new AsfTagInfo( "WM/Director",                         AsfTagDataType.String, true );
			AsfDefinedTags.WmDrm                               = new AsfTagInfo( "WM/DRM",                              AsfTagDataType.String, true );
			AsfDefinedTags.WmDvdId                             = new AsfTagInfo( "WM/DVDID",                            AsfTagDataType.String, true );
			AsfDefinedTags.WmEncodedBy                         = new AsfTagInfo( "WM/EncodedBy",                        AsfTagDataType.String, true );
			AsfDefinedTags.WmEncodingSettings                  = new AsfTagInfo( "WM/EncodingSettings",                 AsfTagDataType.String, true );
			AsfDefinedTags.WmEncodingTime                      = new AsfTagInfo( "WM/EncodingTime",                     AsfTagDataType.UInt64, true );
			AsfDefinedTags.WmGenre                             = new AsfTagInfo( "WM/Genre",                            AsfTagDataType.String, true );
			AsfDefinedTags.WmGenreId                           = new AsfTagInfo( "WM/GenreID",                          AsfTagDataType.String, true );
			AsfDefinedTags.WmInitialKey                        = new AsfTagInfo( "WM/InitialKey",                       AsfTagDataType.String, true );
			AsfDefinedTags.WmIsrc                              = new AsfTagInfo( "WM/ISRC",                             AsfTagDataType.String, true );
			AsfDefinedTags.WmLanguage                          = new AsfTagInfo( "WM/Language",                         AsfTagDataType.String, true );
			AsfDefinedTags.WmLyrics                            = new AsfTagInfo( "WM/Lyrics",                           AsfTagDataType.String, true );
			AsfDefinedTags.WmLyricsSynchronised                = new AsfTagInfo( "WM/Lyrics_Synchronised",              AsfTagDataType.Binary );
			AsfDefinedTags.WmMCDI                              = new AsfTagInfo( "WM/MCDI",                             AsfTagDataType.Binary );
			AsfDefinedTags.WmMediaClassPrimaryId               = new AsfTagInfo( "WM/MediaClassPrimaryID",              AsfTagDataType.Guid   );
			AsfDefinedTags.WmMediaClassSecondaryId             = new AsfTagInfo( "WM/MediaClassSecondaryID",            AsfTagDataType.Guid   );
			AsfDefinedTags.WmMediaCredits                      = new AsfTagInfo( "WM/MediaCredits",                     AsfTagDataType.String, true );
			AsfDefinedTags.WmMediaIsDelay                      = new AsfTagInfo( "WM/MediaIsDelay",                     AsfTagDataType.Bool,   true );
			AsfDefinedTags.WmMediaIsFinale                     = new AsfTagInfo( "WM/MediaIsFinale",                    AsfTagDataType.Bool,   true );
			AsfDefinedTags.WmMediaIsLive                       = new AsfTagInfo( "WM/MediaIsLive",                      AsfTagDataType.Bool,   true );
			AsfDefinedTags.WmMediaIsPremiere                   = new AsfTagInfo( "WM/MediaIsPremiere",                  AsfTagDataType.Bool,   true );
			AsfDefinedTags.WmMediaIsRepeat                     = new AsfTagInfo( "WM/MediaIsRepeat",                    AsfTagDataType.Bool,   true );
			AsfDefinedTags.WmMediaIsSap                        = new AsfTagInfo( "WM/MediaIsSAP",                       AsfTagDataType.Bool,   true );
			AsfDefinedTags.WmMediaIsStereo                     = new AsfTagInfo( "WM/MediaIsStereo",                    AsfTagDataType.Bool,   true );
			AsfDefinedTags.WmMediaIsSubtitled                  = new AsfTagInfo( "WM/MediaIsSubtitled",                 AsfTagDataType.Bool,   true );
			AsfDefinedTags.WmMediaIsTape                       = new AsfTagInfo( "WM/MediaIsTape",                      AsfTagDataType.Bool,   true );
			AsfDefinedTags.WmMediaNetworkAffiliation           = new AsfTagInfo( "WM/MediaNetworkAffiliation",          AsfTagDataType.String, true );
			AsfDefinedTags.WmMediaOriginalBroadcastDateTime    = new AsfTagInfo( "WM/MediaOriginalBroadcastDateTime",   AsfTagDataType.String, true );
			AsfDefinedTags.WmMediaOriginalChannel              = new AsfTagInfo( "WM/MediaOriginalChannel",             AsfTagDataType.String, true );
			AsfDefinedTags.WmMediaStationCallSign              = new AsfTagInfo( "WM/MediaStationCallSign",             AsfTagDataType.String, true );
			AsfDefinedTags.WmMediaStationName                  = new AsfTagInfo( "WM/MediaStationName",                 AsfTagDataType.String, true );
			AsfDefinedTags.WmModifiedBy                        = new AsfTagInfo( "WM/ModifiedBy",                       AsfTagDataType.String, true );
			AsfDefinedTags.WmMood                              = new AsfTagInfo( "WM/Mood",                             AsfTagDataType.String, true );
			AsfDefinedTags.WmOriginalAlbumTitle                = new AsfTagInfo( "WM/OriginalAlbumTitle",               AsfTagDataType.String, true );
			AsfDefinedTags.WmOriginalArtist                    = new AsfTagInfo( "WM/OriginalArtist",                   AsfTagDataType.String, true );
			AsfDefinedTags.WmOriginalFilename                  = new AsfTagInfo( "WM/OriginalFilename",                 AsfTagDataType.String, true );
			AsfDefinedTags.WmOriginalLyricist                  = new AsfTagInfo( "WM/OriginalLyricist",                 AsfTagDataType.String, true );
			AsfDefinedTags.WmOriginalReleaseTime               = new AsfTagInfo( "WM/OriginalReleaseTime",              AsfTagDataType.String, true );
			AsfDefinedTags.WmOriginalReleaseYear               = new AsfTagInfo( "WM/OriginalReleaseYear",              AsfTagDataType.String, true );
			AsfDefinedTags.WmParentalRating                    = new AsfTagInfo( "WM/ParentalRating",                   AsfTagDataType.String, true );
			AsfDefinedTags.WmParentalRatingReason              = new AsfTagInfo( "WM/ParentalRatingReason",             AsfTagDataType.String, true );
			AsfDefinedTags.WmPartOfSet                         = new AsfTagInfo( "WM/PartOfSet",                        AsfTagDataType.String, true );
			AsfDefinedTags.WmPeakBitrate                       = new AsfTagInfo( "WM/PeakBitrate",                      AsfTagDataType.UInt32 );
			AsfDefinedTags.WmPeriod                            = new AsfTagInfo( "WM/Period",                           AsfTagDataType.String, true );
			AsfDefinedTags.WmPicture                           = new AsfTagInfo( "WM/Picture",                          AsfTagDataType.Binary );
			AsfDefinedTags.WmPlaylistDelay                     = new AsfTagInfo( "WM/PlaylistDelay",                    AsfTagDataType.String, true );
			AsfDefinedTags.WmProducer                          = new AsfTagInfo( "WM/Producer",                         AsfTagDataType.String, true );
			AsfDefinedTags.WmPromotionUrl                      = new AsfTagInfo( "WM/PromotionURL",                     AsfTagDataType.String, true );
			AsfDefinedTags.WmProtectionType                    = new AsfTagInfo( "WM/ProtectionType",                   AsfTagDataType.String, true );
			AsfDefinedTags.WmProvider                          = new AsfTagInfo( "WM/Provider",                         AsfTagDataType.String, true );
			AsfDefinedTags.WmProviderCopyright                 = new AsfTagInfo( "WM/ProviderCopyright",                AsfTagDataType.String, true );
			AsfDefinedTags.WmProviderRating                    = new AsfTagInfo( "WM/ProviderRating",                   AsfTagDataType.String, true );
			AsfDefinedTags.WmProviderStyle                     = new AsfTagInfo( "WM/ProviderStyle",                    AsfTagDataType.String, true );
			AsfDefinedTags.WmPublisher                         = new AsfTagInfo( "WM/Publisher",                        AsfTagDataType.String, true );
			AsfDefinedTags.WmRadioStationName                  = new AsfTagInfo( "WM/RadioStationName",                 AsfTagDataType.String, true );
			AsfDefinedTags.WmRadioStationOwner                 = new AsfTagInfo( "WM/RadioStationOwner",                AsfTagDataType.String, true );
			AsfDefinedTags.WmSharedUserRating                  = new AsfTagInfo( "WM/SharedUserRating",                 AsfTagDataType.UInt32, true );
			AsfDefinedTags.WmStreamTypeInfo                    = new AsfTagInfo( "WM/StreamTypeInfo",                   AsfTagDataType.Binary );
			AsfDefinedTags.WmSubscriptionContentId             = new AsfTagInfo( "WM/SubscriptionContentID",            AsfTagDataType.String, true );
			AsfDefinedTags.WmSubTitle                          = new AsfTagInfo( "WM/SubTitle",                         AsfTagDataType.String, true );
			AsfDefinedTags.WmSubTitleDescription               = new AsfTagInfo( "WM/SubTitleDescription",              AsfTagDataType.String, true );
			AsfDefinedTags.WmText                              = new AsfTagInfo( "WM/Text",                             AsfTagDataType.Binary );
			AsfDefinedTags.WmToolName                          = new AsfTagInfo( "WM/ToolName",                         AsfTagDataType.String, true );
			AsfDefinedTags.WmToolVersion                       = new AsfTagInfo( "WM/ToolVersion",                      AsfTagDataType.String, true );
			AsfDefinedTags.WmTrack                             = new AsfTagInfo( "WM/Track",                            AsfTagDataType.String, true );
			AsfDefinedTags.WmTrackNumber                       = new AsfTagInfo( "WM/TrackNumber",                      AsfTagDataType.String, true );
			AsfDefinedTags.WmUniqueFileIdentifier              = new AsfTagInfo( "WM/UniqueFileIdentifier",             AsfTagDataType.String, true );
			AsfDefinedTags.WmUserWebUrl                        = new AsfTagInfo( "WM/UserWebURL",                       AsfTagDataType.Binary );
			AsfDefinedTags.WmVideoClosedCaptioning             = new AsfTagInfo( "WM/VideoClosedCaptioning",            AsfTagDataType.Bool,   true );
			AsfDefinedTags.WmVideoFrameRate                    = new AsfTagInfo( "WM/VideoFrameRate",                   AsfTagDataType.UInt32, true );
			AsfDefinedTags.WmVideoHeight                       = new AsfTagInfo( "WM/VideoHeight",                      AsfTagDataType.UInt32, true );
			AsfDefinedTags.WmVideoWidth                        = new AsfTagInfo( "WM/VideoWidth",                       AsfTagDataType.UInt32, true );
			AsfDefinedTags.WmWmaDRCAverageReference            = new AsfTagInfo( "WM/WMADRCAverageReference",           AsfTagDataType.UInt32 );
			AsfDefinedTags.WmWmaDRCAverageTarget               = new AsfTagInfo( "WM/WMADRCAverageTarget",              AsfTagDataType.UInt32, true );
			AsfDefinedTags.WmWmaDRCPeakReference               = new AsfTagInfo( "WM/WMADRCPeakReference",              AsfTagDataType.UInt32 );
			AsfDefinedTags.WmWmaDRCPeakTarget                  = new AsfTagInfo( "WM/WMADRCPeakTarget",                 AsfTagDataType.UInt32, true );
			AsfDefinedTags.WmWmCollectionGroupId               = new AsfTagInfo( "WM/WMCollectionGroupID",              AsfTagDataType.Guid   );
			AsfDefinedTags.WmWmCollectionId                    = new AsfTagInfo( "WM/WMCollectionID",                   AsfTagDataType.Guid   );
			AsfDefinedTags.WmWmContentId                       = new AsfTagInfo( "WM/WMContentID",                      AsfTagDataType.Guid   );
			AsfDefinedTags.WmWmShadowFileSourceDrmType         = new AsfTagInfo( "WM/WMShadowFileSourceDRMType",        AsfTagDataType.String, true );
			AsfDefinedTags.WmWmShadowFileSourceFileType        = new AsfTagInfo( "WM/WMShadowFileSourceFileType",       AsfTagDataType.String, true );
			AsfDefinedTags.WmWriter                            = new AsfTagInfo( "WM/Writer",                           AsfTagDataType.String, true );
			AsfDefinedTags.WmYear                              = new AsfTagInfo( "WM/Year",                             AsfTagDataType.String, true );

			AsfDefinedTags.Infos = new Dictionary< string, AsfTagInfo >()
			{
				{ AsfDefinedTags.AsfLeakyBucketPairs.Name,               AsfDefinedTags.AsfLeakyBucketPairs               },
				{ AsfDefinedTags.AspectRatioX.Name,                      AsfDefinedTags.AspectRatioX                      },
				{ AsfDefinedTags.AspectRatioY.Name,                      AsfDefinedTags.AspectRatioY                      },
				{ AsfDefinedTags.Author.Name,                            AsfDefinedTags.Author                            },
				{ AsfDefinedTags.AverageLevel.Name,                      AsfDefinedTags.AverageLevel                      },
				{ AsfDefinedTags.BannerImageData.Name,                   AsfDefinedTags.BannerImageData                   },
				{ AsfDefinedTags.BannerImageType.Name,                   AsfDefinedTags.BannerImageType                   },
				{ AsfDefinedTags.BannerImageUrl.Name,                    AsfDefinedTags.BannerImageUrl                    },
				{ AsfDefinedTags.Bitrate.Name,                           AsfDefinedTags.Bitrate                           },
				{ AsfDefinedTags.Broadcast.Name,                         AsfDefinedTags.Broadcast                         },
				{ AsfDefinedTags.BufferAverage.Name,                     AsfDefinedTags.BufferAverage                     },
				{ AsfDefinedTags.CanSkipBackward.Name,                   AsfDefinedTags.CanSkipBackward                   },
				{ AsfDefinedTags.CanSkipForward.Name,                    AsfDefinedTags.CanSkipForward                    },
				{ AsfDefinedTags.Copyright.Name,                         AsfDefinedTags.Copyright                         },
				{ AsfDefinedTags.CopyrightUrl.Name,                      AsfDefinedTags.CopyrightUrl                      },
				{ AsfDefinedTags.CurrentBitrate.Name,                    AsfDefinedTags.CurrentBitrate                    },
				{ AsfDefinedTags.Description.Name,                       AsfDefinedTags.Description                       },
				{ AsfDefinedTags.DrmContentId.Name,                      AsfDefinedTags.DrmContentId                      },
				{ AsfDefinedTags.DrmDrmHeaderContentDistributor.Name,    AsfDefinedTags.DrmDrmHeaderContentDistributor    },
				{ AsfDefinedTags.DrmDrmHeaderContentId.Name,             AsfDefinedTags.DrmDrmHeaderContentId             },
				{ AsfDefinedTags.DrmDrmHeaderIndividualizedVersion.Name, AsfDefinedTags.DrmDrmHeaderIndividualizedVersion },
				{ AsfDefinedTags.DrmDrmHeaderKeyId.Name,                 AsfDefinedTags.DrmDrmHeaderKeyId                 },
				{ AsfDefinedTags.DrmDrmHeaderLicenseAcqUrl.Name,         AsfDefinedTags.DrmDrmHeaderLicenseAcqUrl         },
				{ AsfDefinedTags.DrmDrmHeaderSubscriptionContentId.Name, AsfDefinedTags.DrmDrmHeaderSubscriptionContentId },
				{ AsfDefinedTags.DrmDrmHeader.Name,                      AsfDefinedTags.DrmDrmHeader                      },
				{ AsfDefinedTags.DrmIndividualizedVersion.Name,          AsfDefinedTags.DrmIndividualizedVersion          },
				{ AsfDefinedTags.DrmKeyId.Name,                          AsfDefinedTags.DrmKeyId                          },
				{ AsfDefinedTags.DrmLaSignatureCert.Name,                AsfDefinedTags.DrmLaSignatureCert                },
				{ AsfDefinedTags.DrmLaSignatureLicSrvCert.Name,          AsfDefinedTags.DrmLaSignatureLicSrvCert          },
				{ AsfDefinedTags.DrmLaSignaturePrivKey.Name,             AsfDefinedTags.DrmLaSignaturePrivKey             },
				{ AsfDefinedTags.DrmLaSignatureRootCert.Name,            AsfDefinedTags.DrmLaSignatureRootCert            },
				{ AsfDefinedTags.DrmLicenseAcqUrl.Name,                  AsfDefinedTags.DrmLicenseAcqUrl                  },
				{ AsfDefinedTags.DrmLicenseId.Name,                      AsfDefinedTags.DrmLicenseId                      },
				{ AsfDefinedTags.DrmSourceId.Name,                       AsfDefinedTags.DrmSourceId                       },
				{ AsfDefinedTags.DrmV1LicenseAcqUrl.Name,                AsfDefinedTags.DrmV1LicenseAcqUrl                },
				{ AsfDefinedTags.Duration.Name,                          AsfDefinedTags.Duration                          },
				{ AsfDefinedTags.FileSize.Name,                          AsfDefinedTags.FileSize                          },
				{ AsfDefinedTags.HasArbitraryDataStream.Name,            AsfDefinedTags.HasArbitraryDataStream            },
				{ AsfDefinedTags.HasAttachedImages.Name,                 AsfDefinedTags.HasAttachedImages                 },
				{ AsfDefinedTags.HasAudio.Name,                          AsfDefinedTags.HasAudio                          },
				{ AsfDefinedTags.HasFileTransferStream.Name,             AsfDefinedTags.HasFileTransferStream             },
				{ AsfDefinedTags.HasImage.Name,                          AsfDefinedTags.HasImage                          },
				{ AsfDefinedTags.HasScript.Name,                         AsfDefinedTags.HasScript                         },
				{ AsfDefinedTags.HasVideo.Name,                          AsfDefinedTags.HasVideo                          },
				{ AsfDefinedTags.IsProtected.Name,                       AsfDefinedTags.IsProtected                       },
				{ AsfDefinedTags.IsTrusted.Name,                         AsfDefinedTags.IsTrusted                         },
				{ AsfDefinedTags.Isan.Name,                              AsfDefinedTags.Isan                              },
				{ AsfDefinedTags.IsVBR.Name,                             AsfDefinedTags.IsVBR                             },
				{ AsfDefinedTags.NscAddress.Name,                        AsfDefinedTags.NscAddress                        },
				{ AsfDefinedTags.NscDescription.Name,                    AsfDefinedTags.NscDescription                    },
				{ AsfDefinedTags.NscEmail.Name,                          AsfDefinedTags.NscEmail                          },
				{ AsfDefinedTags.NscName.Name,                           AsfDefinedTags.NscName                           },
				{ AsfDefinedTags.NscPhone.Name,                          AsfDefinedTags.NscPhone                          },
				{ AsfDefinedTags.NumberOfFrames.Name,                    AsfDefinedTags.NumberOfFrames                    },
				{ AsfDefinedTags.OptimalBitrate.Name,                    AsfDefinedTags.OptimalBitrate                    },
				{ AsfDefinedTags.PeakValue.Name,                         AsfDefinedTags.PeakValue                         },
				{ AsfDefinedTags.Rating.Name,                            AsfDefinedTags.Rating                            },
				{ AsfDefinedTags.Seekable.Name,                          AsfDefinedTags.Seekable                          },
				{ AsfDefinedTags.Signature_Name.Name,                    AsfDefinedTags.Signature_Name                    },
				{ AsfDefinedTags.Stridable.Name,                         AsfDefinedTags.Stridable                         },
				{ AsfDefinedTags.Title.Name,                             AsfDefinedTags.Title                             },
				{ AsfDefinedTags.VbrPeak.Name,                           AsfDefinedTags.VbrPeak                           },
				{ AsfDefinedTags.WmAlbumArtist.Name,                     AsfDefinedTags.WmAlbumArtist                     },
				{ AsfDefinedTags.WmAlbumCoverUrl.Name,                   AsfDefinedTags.WmAlbumCoverUrl                   },
				{ AsfDefinedTags.WmAlbumTitle.Name,                      AsfDefinedTags.WmAlbumTitle                      },
				{ AsfDefinedTags.WmAsfPacketCount.Name,                  AsfDefinedTags.WmAsfPacketCount                  },
				{ AsfDefinedTags.WmAsfSecurityObjectsSize.Name,          AsfDefinedTags.WmAsfSecurityObjectsSize          },
				{ AsfDefinedTags.WmAudioFileUrl.Name,                    AsfDefinedTags.WmAudioFileUrl                    },
				{ AsfDefinedTags.WmAudioSourceUrl.Name,                  AsfDefinedTags.WmAudioSourceUrl                  },
				{ AsfDefinedTags.WmAuthorUrl.Name,                       AsfDefinedTags.WmAuthorUrl                       },
				{ AsfDefinedTags.WmBeatsPerMinute.Name,                  AsfDefinedTags.WmBeatsPerMinute                  },
				{ AsfDefinedTags.WmCategory.Name,                        AsfDefinedTags.WmCategory                        },
				{ AsfDefinedTags.WmCodec.Name,                           AsfDefinedTags.WmCodec                           },
				{ AsfDefinedTags.WmComposer.Name,                        AsfDefinedTags.WmComposer                        },
				{ AsfDefinedTags.WmConductor.Name,                       AsfDefinedTags.WmConductor                       },
				{ AsfDefinedTags.WmContainerFormat.Name,                 AsfDefinedTags.WmContainerFormat                 },
				{ AsfDefinedTags.WmContentDistributor.Name,              AsfDefinedTags.WmContentDistributor              },
				{ AsfDefinedTags.WmContentGroupDescription.Name,         AsfDefinedTags.WmContentGroupDescription         },
				{ AsfDefinedTags.WmDirector.Name,                        AsfDefinedTags.WmDirector                        },
				{ AsfDefinedTags.WmDrm.Name,                             AsfDefinedTags.WmDrm                             },
				{ AsfDefinedTags.WmDvdId.Name,                           AsfDefinedTags.WmDvdId                           },
				{ AsfDefinedTags.WmEncodedBy.Name,                       AsfDefinedTags.WmEncodedBy                       },
				{ AsfDefinedTags.WmEncodingSettings.Name,                AsfDefinedTags.WmEncodingSettings                },
				{ AsfDefinedTags.WmEncodingTime.Name,                    AsfDefinedTags.WmEncodingTime                    },
				{ AsfDefinedTags.WmGenre.Name,                           AsfDefinedTags.WmGenre                           },
				{ AsfDefinedTags.WmGenreId.Name,                         AsfDefinedTags.WmGenreId                         },
				{ AsfDefinedTags.WmInitialKey.Name,                      AsfDefinedTags.WmInitialKey                      },
				{ AsfDefinedTags.WmIsrc.Name,                            AsfDefinedTags.WmIsrc                            },
				{ AsfDefinedTags.WmLanguage.Name,                        AsfDefinedTags.WmLanguage                        },
				{ AsfDefinedTags.WmLyrics.Name,                          AsfDefinedTags.WmLyrics                          },
				{ AsfDefinedTags.WmLyricsSynchronised.Name,              AsfDefinedTags.WmLyricsSynchronised              },
				{ AsfDefinedTags.WmMCDI.Name,                            AsfDefinedTags.WmMCDI                            },
				{ AsfDefinedTags.WmMediaClassPrimaryId.Name,             AsfDefinedTags.WmMediaClassPrimaryId             },
				{ AsfDefinedTags.WmMediaClassSecondaryId.Name,           AsfDefinedTags.WmMediaClassSecondaryId           },
				{ AsfDefinedTags.WmMediaCredits.Name,                    AsfDefinedTags.WmMediaCredits                    },
				{ AsfDefinedTags.WmMediaIsDelay.Name,                    AsfDefinedTags.WmMediaIsDelay                    },
				{ AsfDefinedTags.WmMediaIsFinale.Name,                   AsfDefinedTags.WmMediaIsFinale                   },
				{ AsfDefinedTags.WmMediaIsLive.Name,                     AsfDefinedTags.WmMediaIsLive                     },
				{ AsfDefinedTags.WmMediaIsPremiere.Name,                 AsfDefinedTags.WmMediaIsPremiere                 },
				{ AsfDefinedTags.WmMediaIsRepeat.Name,                   AsfDefinedTags.WmMediaIsRepeat                   },
				{ AsfDefinedTags.WmMediaIsSap.Name,                      AsfDefinedTags.WmMediaIsSap                      },
				{ AsfDefinedTags.WmMediaIsStereo.Name,                   AsfDefinedTags.WmMediaIsStereo                   },
				{ AsfDefinedTags.WmMediaIsSubtitled.Name,                AsfDefinedTags.WmMediaIsSubtitled                },
				{ AsfDefinedTags.WmMediaIsTape.Name,                     AsfDefinedTags.WmMediaIsTape                     },
				{ AsfDefinedTags.WmMediaNetworkAffiliation.Name,         AsfDefinedTags.WmMediaNetworkAffiliation         },
				{ AsfDefinedTags.WmMediaOriginalBroadcastDateTime.Name,  AsfDefinedTags.WmMediaOriginalBroadcastDateTime  },
				{ AsfDefinedTags.WmMediaOriginalChannel.Name,            AsfDefinedTags.WmMediaOriginalChannel            },
				{ AsfDefinedTags.WmMediaStationCallSign.Name,            AsfDefinedTags.WmMediaStationCallSign            },
				{ AsfDefinedTags.WmMediaStationName.Name,                AsfDefinedTags.WmMediaStationName                },
				{ AsfDefinedTags.WmModifiedBy.Name,                      AsfDefinedTags.WmModifiedBy                      },
				{ AsfDefinedTags.WmMood.Name,                            AsfDefinedTags.WmMood                            },
				{ AsfDefinedTags.WmOriginalAlbumTitle.Name,              AsfDefinedTags.WmOriginalAlbumTitle              },
				{ AsfDefinedTags.WmOriginalArtist.Name,                  AsfDefinedTags.WmOriginalArtist                  },
				{ AsfDefinedTags.WmOriginalFilename.Name,                AsfDefinedTags.WmOriginalFilename                },
				{ AsfDefinedTags.WmOriginalLyricist.Name,                AsfDefinedTags.WmOriginalLyricist                },
				{ AsfDefinedTags.WmOriginalReleaseTime.Name,             AsfDefinedTags.WmOriginalReleaseTime             },
				{ AsfDefinedTags.WmOriginalReleaseYear.Name,             AsfDefinedTags.WmOriginalReleaseYear             },
				{ AsfDefinedTags.WmParentalRating.Name,                  AsfDefinedTags.WmParentalRating                  },
				{ AsfDefinedTags.WmParentalRatingReason.Name,            AsfDefinedTags.WmParentalRatingReason            },
				{ AsfDefinedTags.WmPartOfSet.Name,                       AsfDefinedTags.WmPartOfSet                       },
				{ AsfDefinedTags.WmPeakBitrate.Name,                     AsfDefinedTags.WmPeakBitrate                     },
				{ AsfDefinedTags.WmPeriod.Name,                          AsfDefinedTags.WmPeriod                          },
				{ AsfDefinedTags.WmPicture.Name,                         AsfDefinedTags.WmPicture                         },
				{ AsfDefinedTags.WmPlaylistDelay.Name,                   AsfDefinedTags.WmPlaylistDelay                   },
				{ AsfDefinedTags.WmProducer.Name,                        AsfDefinedTags.WmProducer                        },
				{ AsfDefinedTags.WmPromotionUrl.Name,                    AsfDefinedTags.WmPromotionUrl                    },
				{ AsfDefinedTags.WmProtectionType.Name,                  AsfDefinedTags.WmProtectionType                  },
				{ AsfDefinedTags.WmProvider.Name,                        AsfDefinedTags.WmProvider                        },
				{ AsfDefinedTags.WmProviderCopyright.Name,               AsfDefinedTags.WmProviderCopyright               },
				{ AsfDefinedTags.WmProviderRating.Name,                  AsfDefinedTags.WmProviderRating                  },
				{ AsfDefinedTags.WmProviderStyle.Name,                   AsfDefinedTags.WmProviderStyle                   },
				{ AsfDefinedTags.WmPublisher.Name,                       AsfDefinedTags.WmPublisher                       },
				{ AsfDefinedTags.WmRadioStationName.Name,                AsfDefinedTags.WmRadioStationName                },
				{ AsfDefinedTags.WmRadioStationOwner.Name,               AsfDefinedTags.WmRadioStationOwner               },
				{ AsfDefinedTags.WmSharedUserRating.Name,                AsfDefinedTags.WmSharedUserRating                },
				{ AsfDefinedTags.WmStreamTypeInfo.Name,                  AsfDefinedTags.WmStreamTypeInfo                  },
				{ AsfDefinedTags.WmSubscriptionContentId.Name,           AsfDefinedTags.WmSubscriptionContentId           },
				{ AsfDefinedTags.WmSubTitle.Name,                        AsfDefinedTags.WmSubTitle                        },
				{ AsfDefinedTags.WmSubTitleDescription.Name,             AsfDefinedTags.WmSubTitleDescription             },
				{ AsfDefinedTags.WmText.Name,                            AsfDefinedTags.WmText                            },
				{ AsfDefinedTags.WmToolName.Name,                        AsfDefinedTags.WmToolName                        },
				{ AsfDefinedTags.WmToolVersion.Name,                     AsfDefinedTags.WmToolVersion                     },
				{ AsfDefinedTags.WmTrack.Name,                           AsfDefinedTags.WmTrack                           },
				{ AsfDefinedTags.WmTrackNumber.Name,                     AsfDefinedTags.WmTrackNumber                     },
				{ AsfDefinedTags.WmUniqueFileIdentifier.Name,            AsfDefinedTags.WmUniqueFileIdentifier            },
				{ AsfDefinedTags.WmUserWebUrl.Name,                      AsfDefinedTags.WmUserWebUrl                      },
				{ AsfDefinedTags.WmVideoClosedCaptioning.Name,           AsfDefinedTags.WmVideoClosedCaptioning           },
				{ AsfDefinedTags.WmVideoFrameRate.Name,                  AsfDefinedTags.WmVideoFrameRate                  },
				{ AsfDefinedTags.WmVideoHeight.Name,                     AsfDefinedTags.WmVideoHeight                     },
				{ AsfDefinedTags.WmVideoWidth.Name,                      AsfDefinedTags.WmVideoWidth                      },
				{ AsfDefinedTags.WmWmaDRCAverageReference.Name,          AsfDefinedTags.WmWmaDRCAverageReference          },
				{ AsfDefinedTags.WmWmaDRCAverageTarget.Name,             AsfDefinedTags.WmWmaDRCAverageTarget             },
				{ AsfDefinedTags.WmWmaDRCPeakReference.Name,             AsfDefinedTags.WmWmaDRCPeakReference             },
				{ AsfDefinedTags.WmWmaDRCPeakTarget.Name,                AsfDefinedTags.WmWmaDRCPeakTarget                },
				{ AsfDefinedTags.WmWmCollectionGroupId.Name,             AsfDefinedTags.WmWmCollectionGroupId             },
				{ AsfDefinedTags.WmWmCollectionId.Name,                  AsfDefinedTags.WmWmCollectionId                  },
				{ AsfDefinedTags.WmWmContentId.Name,                     AsfDefinedTags.WmWmContentId                     },
				{ AsfDefinedTags.WmWmShadowFileSourceDrmType.Name,       AsfDefinedTags.WmWmShadowFileSourceDrmType       },
				{ AsfDefinedTags.WmWmShadowFileSourceFileType.Name,      AsfDefinedTags.WmWmShadowFileSourceFileType      },
				{ AsfDefinedTags.WmWriter.Name,                          AsfDefinedTags.WmWriter                          },
				{ AsfDefinedTags.WmYear.Name,                            AsfDefinedTags.WmYear                            }
			};
		}

		/// <summary>
		/// 指定された名前を持つタグ情報を取得します。
		/// </summary>
		/// <param name="name">名前。</param>
		/// <returns>成功時はタグ情報。それ以外は null 参照。</returns>
		internal static AsfTagInfo GetInfo( string name )
		{
			AsfTagInfo info;
			return ( AsfDefinedTags.Infos.TryGetValue( name, out info ) ? info : null );
		}

		/// <summary>
		/// タグ情報のコレクションを取得します。
		/// </summary>
		/// <returns>タグ情報のコレクション。</returns>
		public static IEnumerable< AsfTagInfo > GetTags()
		{
			return AsfDefinedTags.Infos.Values;
		}

		/// <summary>
		/// 指定された名前を持つタグが定義されていることを調べます。
		/// </summary>
		/// <param name="name">名前。</param>
		/// <returns>定義されている場合は true。それ以外は false。</returns>
		internal static bool HasInfo( string name )
		{
			return AsfDefinedTags.Infos.ContainsKey( name );
		}

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo AsfLeakyBucketPairs { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo AspectRatioX { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo AspectRatioY { get; private set; }

		/// <summary>
		/// アーティストを示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo Author { get; private set; }

		/// <summary>
		/// 音量の平均値を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo AverageLevel { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo BannerImageData { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo BannerImageType { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo BannerImageUrl { get; private set; }

		/// <summary>
		/// 平均ビットレートを示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo Bitrate { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo Broadcast { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo BufferAverage { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo CanSkipBackward { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo CanSkipForward { get; private set; }

		/// <summary>
		/// 著作権情報を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo Copyright { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo CopyrightUrl { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo CurrentBitrate { get; private set; }

		/// <summary>
		/// コメントを示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo Description { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo DrmContentId { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo DrmDrmHeaderContentDistributor { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo DrmDrmHeaderContentId { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo DrmDrmHeaderIndividualizedVersion { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo DrmDrmHeaderKeyId { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo DrmDrmHeaderLicenseAcqUrl { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo DrmDrmHeaderSubscriptionContentId { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo DrmDrmHeader { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo DrmIndividualizedVersion { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo DrmKeyId { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo DrmLaSignatureCert { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo DrmLaSignatureLicSrvCert { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo DrmLaSignaturePrivKey { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo DrmLaSignatureRootCert { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo DrmLicenseAcqUrl { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo DrmLicenseId { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo DrmSourceId { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo DrmV1LicenseAcqUrl { get; private set; }

		/// <summary>
		/// 演奏時間を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo Duration { get; private set; }

		/// <summary>
		/// ファイルサイズを示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo FileSize { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo HasArbitraryDataStream { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo HasAttachedImages { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo HasAudio { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo HasFileTransferStream { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo HasImage { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo HasScript { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo HasVideo { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo IsProtected { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo IsTrusted { get; private set; }

		/// <summary>
		/// 国際標準視聴覚番号 ( International Standard Audiovisual Number ) を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo Isan { get; private set; }

		/// <summary>
		/// 可変ビットレートでエンコードされたことを示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo IsVBR { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo NscAddress { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo NscDescription { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo NscEmail { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo NscName { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo NscPhone { get; private set; }

		/// <summary>
		/// ビデオストリームのフレーム数を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo NumberOfFrames { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo OptimalBitrate { get; private set; }

		/// <summary>
		/// 音量の最大値を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo PeakValue { get; private set; }

		/// <summary>
		/// 保護者による制限を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo Rating { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo Seekable { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo Signature_Name { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo Stridable { get; private set; }

		/// <summary>
		/// タイトルを示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo Title { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo VbrPeak { get; private set; }

		/// <summary>
		/// アルバムのアーティスト名を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmAlbumArtist { get; private set; }

		/// <summary>
		/// アルバムのジャケット画像に関する情報サイトの URL を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmAlbumCoverUrl { get; private set; }

		/// <summary>
		/// アルバム名を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmAlbumTitle { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo WmAsfPacketCount { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo WmAsfSecurityObjectsSize { get; private set; }

		/// <summary>
		/// 音楽ファイルのサイト ( アルバムやアーティスト情報 ) URL を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmAudioFileUrl { get; private set; }

		/// <summary>
		/// 音楽の使用された作品 ( 映画や TV など ) のサイトへの URL を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmAudioSourceUrl { get; private set; }

		/// <summary>
		/// アーティストの URL を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmAuthorUrl { get; private set; }

		/// <summary>
		/// テンポ ( 1 分間の拍数 ) を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmBeatsPerMinute { get; private set; }

		/// <summary>
		/// カテゴリを示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmCategory { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo WmCodec { get; private set; }

		/// <summary>
		/// 作曲者を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmComposer { get; private set; }

		/// <summary>
		/// 指揮者を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmConductor { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo WmContainerFormat { get; private set; }

		/// <summary>
		/// ファイルの提供者を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmContentDistributor { get; private set; }

		/// <summary>
		/// 所属するグループの情報 ( 音楽ならば CD、ビデオならばシリーズの情報など ) を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmContentGroupDescription { get; private set; }

		/// <summary>
		/// ディレクターを示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmDirector { get; private set; }

		/// <summary>
		/// DRM で保護されていることを示す情報を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmDrm { get; private set; }

		/// <summary>
		/// DVD の識別子を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmDvdId { get; private set; }

		/// <summary>
		/// エンコードをおこなった人を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmEncodedBy { get; private set; }

		/// <summary>
		/// エンコード設定を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmEncodingSettings { get; private set; }

		/// <summary>
		/// エンコードをおこなった時間を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmEncodingTime { get; private set; }

		/// <summary>
		/// ジャンルを示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmGenre { get; private set; }

		/// <summary>
		/// ジャンル ID を示すタグ定義を取得します。
		/// この情報は ID3v2 の TCON タグに準拠しています。
		/// 通常、"(17) Rock" のように、括弧にジャンルを表す数値を入れ、後続の文字列にジャンル名を格納します。
		/// 詳細は ID3v2 の仕様を参照してください。
		/// </summary>
		public static AsfTagInfo WmGenreId { get; private set; }

		/// <summary>
		/// 曲頭のキー ( C、Am、F♯ といった調の文字列 ) を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmInitialKey { get; private set; }

		/// <summary>
		/// 国際標準レコーディングコード（ International Standard Recording Code ) を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmIsrc { get; private set; }

		/// <summary>
		/// 言語を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmLanguage { get; private set; }

		/// <summary>
		/// 歌詞を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmLyrics { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo WmLyricsSynchronised { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo WmMCDI { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo WmMediaClassPrimaryId { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo WmMediaClassSecondaryId { get; private set; }

		/// <summary>
		/// 放送をおこなったメディア名を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmMediaCredits { get; private set; }

		/// <summary>
		/// 放送時におけるテープ遅延の有無を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmMediaIsDelay { get; private set; }

		/// <summary>
		/// シリーズの最終回であることを示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmMediaIsFinale { get; private set; }

		/// <summary>
		/// 生放送であることを示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmMediaIsLive { get; private set; }

		/// <summary>
		/// シリーズの初回であることを示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmMediaIsPremiere { get; private set; }

		/// <summary>
		/// 再放送であることを示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmMediaIsRepeat { get; private set; }

		/// <summary>
		/// 音声多重放送 ( Second Audio Program ) であることを示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmMediaIsSap { get; private set; }

		/// <summary>
		/// ステレオ放送であることを示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmMediaIsStereo { get; private set; }

		/// <summary>
		/// 字幕を持つことを示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmMediaIsSubtitled { get; private set; }

		/// <summary>
		/// 収録放送されたことを示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmMediaIsTape { get; private set; }

		/// <summary>
		/// コンテンツ配信をおこなうネットワーク情報を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmMediaNetworkAffiliation { get; private set; }

		/// <summary>
		/// 放送日時を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmMediaOriginalBroadcastDateTime { get; private set; }

		/// <summary>
		/// 放送したチャンネルを示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmMediaOriginalChannel { get; private set; }

		/// <summary>
		/// 放送局の識別信号を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmMediaStationCallSign { get; private set; }

		/// <summary>
		/// 放送局の名前を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmMediaStationName { get; private set; }

		/// <summary>
		/// ファイルを更新したグループ、または個人名を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmModifiedBy { get; private set; }

		/// <summary>
		/// 曲の雰囲気を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmMood { get; private set; }

		/// <summary>
		/// 曲の初出となるアルバムを示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmOriginalAlbumTitle { get; private set; }

		/// <summary>
		/// 原曲のアーティストを示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmOriginalArtist { get; private set; }

		/// <summary>
		/// 元のファイル名を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmOriginalFilename { get; private set; }

		/// <summary>
		/// 原曲の作詞者を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmOriginalLyricist { get; private set; }

		/// <summary>
		/// 原曲がリリースされた時間を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmOriginalReleaseTime { get; private set; }

		/// <summary>
		/// 原曲がリリースされた年を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmOriginalReleaseYear { get; private set; }

		/// <summary>
		/// 保護者による制限を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmParentalRating { get; private set; }

		/// <summary>
		/// 保護者による制限の理由を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmParentalRatingReason { get; private set; }

		/// <summary>
		/// 曲の属するグループ内の番号 ( スラッシュ区切りの文字列 ) を示すタグ定義を取得します。
		/// 複数枚や複数の組曲で構成されるアルバムの場合、それらの総数と何番目に位置するかを表します。
		/// 例えば 3 枚組のアルバムにおいて、2 枚目に属する曲ならば "2/3" となります。
		/// </summary>
		public static AsfTagInfo WmPartOfSet { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo WmPeakBitrate { get; private set; }

		/// <summary>
		/// 音楽の年代を示すタグ定義を取得します。
		/// 例えばバロックやルネッサンスなど、ある時代を指すために使用します。
		/// </summary>
		public static AsfTagInfo WmPeriod { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo WmPicture { get; private set; }

		/// <summary>
		/// プレイリスト内の曲を再生する前に必要な遅延時間 ( ミリ秒単位 ) を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmPlaylistDelay { get; private set; }

		/// <summary>
		/// プロデューサーを示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmProducer { get; private set; }

		/// <summary>
		/// プロモーション用の URL を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmPromotionUrl { get; private set; }

		/// <summary>
		/// コンテンツを保護する方法の種別を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmProtectionType { get; private set; }

		/// <summary>
		/// メタデータ提供サービス ( CDDB や AMG など ) を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmProvider { get; private set; }

		/// <summary>
		/// コンテンツを配信するプロパイダの著作権情報を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmProviderCopyright { get; private set; }

		/// <summary>
		/// メタデータ提供サービスによる評価を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmProviderRating { get; private set; }

		/// <summary>
		/// メタデータ提供サービスによるスタイル ( 副次的なジャンル ) 指定を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmProviderStyle { get; private set; }

		/// <summary>
		/// 曲の発行元 ( レーベル ) を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmPublisher { get; private set; }

		/// <summary>
		/// ラジオ局の名前を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmRadioStationName { get; private set; }

		/// <summary>
		/// ラジオ局の所有者を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmRadioStationOwner { get; private set; }

		/// <summary>
		/// 複数のユーザーによる評価を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmSharedUserRating { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo WmStreamTypeInfo { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo WmSubscriptionContentId { get; private set; }

		/// <summary>
		/// 副題を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmSubTitle { get; private set; }

		/// <summary>
		/// 副題の補足情報を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmSubTitleDescription { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo WmText { get; private set; }

		/// <summary>
		/// ファイル作成に使用したツールを示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmToolName { get; private set; }

		/// <summary>
		/// ファイル作成に使用したツールのバージョン情報を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmToolVersion { get; private set; }

		/// <summary>
		/// トラック番号 ( 0 から開始 ) を示すタグ定義を取得します。
		/// このデータは下位互換のために残されており、現在は WmTrackNumber を代りに使用します。
		/// </summary>
		public static AsfTagInfo WmTrack { get; private set; }

		/// <summary>
		/// トラック番号 ( 1 から開始 ) を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmTrackNumber { get; private set; }

		/// <summary>
		/// ファイルの識別子 ( セミコロンで区切られた任意の値 ) を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmUniqueFileIdentifier { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo WmUserWebUrl { get; private set; }

		/// <summary>
		/// クローズドキャプションを含むことを示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmVideoClosedCaptioning { get; private set; }

		/// <summary>
		/// ビデオのフレームレート
		/// </summary>
		public static AsfTagInfo WmVideoFrameRate { get; private set; }

		/// <summary>
		/// ビデオの高さ ( ピクセル単位 ) を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmVideoHeight { get; private set; }

		/// <summary>
		/// ビデオの幅 ( ピクセル単位 ) を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmVideoWidth { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo WmWmaDRCAverageReference { get; private set; }

		/// <summary>
		/// 平均音量レベルを示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmWmaDRCAverageTarget { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo WmWmaDRCPeakReference { get; private set; }

		/// <summary>
		/// 最大音量レベルを示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmWmaDRCPeakTarget { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo WmWmCollectionGroupId { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo WmWmCollectionId { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static AsfTagInfo WmWmContentId { get; private set; }

		/// <summary>
		/// 元ファイルの著作権保護方法を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmWmShadowFileSourceDrmType { get; private set; }

		/// <summary>
		/// 元ファイルの種別を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmWmShadowFileSourceFileType { get; private set; }

		/// <summary>
		/// 作詞者を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmWriter { get; private set; }

		/// <summary>
		/// リリースされた年を示すタグ定義を取得します。
		/// </summary>
		public static AsfTagInfo WmYear { get; private set; }

		/// <summary>
		/// タグ名をキーとするタグ情報のディクショナリ。
		/// </summary>
		private static Dictionary< string, AsfTagInfo > Infos;
	}
}
