﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace Parade.Metadata.Id3
{
	/// <summary>
	/// フレームのヘッダ情報を表します。
	/// </summary>
	class FrameHeader
	{
		/// <summary>
		/// インスタンスを初期化します。
		/// </summary>
		/// <param name="reader">タグ情報を読み取るためのストリーム。</param>
		/// <param name="isV22">ID3v2.2 なら true。それ以外は false。</param>
		public FrameHeader( Stream reader, bool isV22 )
		{
			if( isV22 )
			{
				this.Id = reader.ReadStringAscii( 3 );
			}
			else
			{

			}
		}

		/// <summary>
		/// ID を設定または取得します。
		/// </summary>
		public string Id { get; set; }

		/// <summary>
		/// サイズを設定または取得します。
		/// </summary>
		public int Size { get; set; }
	}
}
